using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// The LoginForm is used to get Records Manager login
	/// information.
	/// </summary>
	public class LoginForm : System.Windows.Forms.Form
	{
		public LoginForm(ClientSession session, Control parent, IRMList list, string userName,  string databaseName, string language)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			util = new Util(this,parent);
			m_session = session;
			m_list = list;
			m_name = databaseName;
			m_language = language;
			m_userName = userName;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.txtUserName = new System.Windows.Forms.TextBox();
			this.comboBoxDataSource = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.btnOkay = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(136, 40);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(240, 20);
			this.txtPassword.TabIndex = 2;
			this.txtPassword.Text = "";
			// 
			// txtUserName
			// 
			this.txtUserName.Location = new System.Drawing.Point(136, 16);
			this.txtUserName.Name = "txtUserName";
			this.txtUserName.Size = new System.Drawing.Size(240, 20);
			this.txtUserName.TabIndex = 1;
			this.txtUserName.Text = "administrator";
			// 
			// comboBoxDataSource
			// 
			this.comboBoxDataSource.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxDataSource.Location = new System.Drawing.Point(136, 64);
			this.comboBoxDataSource.Name = "comboBoxDataSource";
			this.comboBoxDataSource.Size = new System.Drawing.Size(240, 21);
			this.comboBoxDataSource.TabIndex = 3;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 64);
			this.label4.Name = "label4";
			this.label4.TabIndex = 8;
			this.label4.Text = "Datasource";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 40);
			this.label3.Name = "label3";
			this.label3.TabIndex = 7;
			this.label3.Text = "Password";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 16);
			this.label2.Name = "label2";
			this.label2.TabIndex = 6;
			this.label2.Text = "User Name";
			// 
			// btnOkay
			// 
			this.btnOkay.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOkay.Location = new System.Drawing.Point(296, 120);
			this.btnOkay.Name = "btnOkay";
			this.btnOkay.TabIndex = 5;
			this.btnOkay.Text = "Okay";
			this.btnOkay.Click += new System.EventHandler(this.btnOkay_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(208, 120);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 4;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// LoginForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 157);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOkay);
			this.Controls.Add(this.txtPassword);
			this.Controls.Add(this.txtUserName);
			this.Controls.Add(this.comboBoxDataSource);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Name = "LoginForm";
			this.Text = "LoginForm";
			this.Load += new System.EventHandler(this.LoginForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#region events
		private void LoginForm_Load(object sender, System.EventArgs e)
		{
			//TODO rmove this shortcut
			txtPassword.Text = "cronos";

			txtUserName.Text = m_userName;
				
			comboBoxDataSource.Items.Clear();

			for(int i = 0; i < m_list.Count; i++)
			{
				int index = comboBoxDataSource.Items.Add(m_list.PrimaryKey(i));
				if(m_name.Equals(m_list.Caption(i)))
				{
					comboBoxDataSource.SelectedIndex = index;
				}
			}
		}

		private void btnOkay_Click(object sender, System.EventArgs e)
		{
			try
			{
				m_session.login(txtUserName.Text,txtPassword.Text,SelectedDatabaseName,"",this.m_language);
				DialogResult = DialogResult.OK;
			}
			catch(System.Net.WebException we)
			{
				util.logWebException(we);
				DialogResult = DialogResult.Abort;
			}
			catch(System.Web.Services.Protocols.SoapException s)
			{
				util.handleSoapException(s,false); //false indicates we will not check for time ou here
				util.showSoapException(s);
				DialogResult = DialogResult.Abort;
			}
			this.Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			this.Close();
		}
		#endregion

		public string SelectedDatabaseName
		{
			get
			{
				return (string)comboBoxDataSource.Items[comboBoxDataSource.SelectedIndex];
			}
		}

		public string SelectedUserName
		{
			get
			{
				return txtUserName.Text;
			}
		}

		#region MemberVariables
		private Util util;
		private ClientSession m_session;
		private IRMList m_list;
		private string m_name;
		private string m_language;
		private string m_userName;

		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.TextBox txtUserName;
		private System.Windows.Forms.ComboBox comboBoxDataSource;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnOkay;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion

	}
}
