package com.ibm.gre.dod.extension;

import java.util.EventObject;
import java.util.HashMap;

import javax.ejb.CreateException;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.ibm.gre.engine.ejb.facade.FilePlanComponentContentControllerEJBLocal;
import com.ibm.gre.engine.ejb.facade.FilePlanComponentContentControllerEJBLocalHome;
import com.ibm.gre.engine.ejb.facade.FilePlanComponentControllerEJBLocal;
import com.ibm.gre.engine.ejb.facade.FilePlanComponentControllerEJBLocalHome;
import com.ibm.gre.engine.ejb.facade.NavigationControllerEJBLocal;
import com.ibm.gre.engine.ejb.facade.NavigationControllerEJBLocalHome;
import com.ibm.gre.engine.extension.FilePlanComponentListener;
import com.ibm.gre.engine.util.BusinessComponentsJNDINames;
import com.ibm.gre.engine.util.BusinessLayerError;
import com.ibm.gre.engine.util.DispositionTypes;
import com.ibm.gre.engine.util.ExtensionParamKeys;
import com.ibm.gre.engine.util.RecordManagerException;
import com.ibm.gre.engine.util.RecordManagerExceptionTypes;
import com.ibm.gre.engine.util.ServiceLocator;
import com.ibm.gre.engine.util.XMLUtil;
import com.ibm.gre.engine.value.StateMachine;

public class PDFAlertExtension implements FilePlanComponentListener {

	private static Logger logger = Logger.getLogger("EXTENSION");
	
	public void afterAddEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterAddEvent");
	}

	public void afterDeleteEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterDeleteEvent");
	}

	public void afterGetByBarCodeEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterGetByBarCodeEvent");
	}

	public void afterGetByIDEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterGetByIDEvent");
	}

	public void afterGetFieldEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterGetFieldEvent");
	}

	public void afterSetFieldEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterSetFieldEvent");
	}

	public void afterSupercedeEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterSupercedeEvent");
	}

	public void afterTransitionEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterTransitionEvent");
	}

	public void afterUpdateEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterUpdateEvent");
	}

	public void beforeAddEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeAddEvent");
	}

	public void beforeDeleteEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeDeleteEvent");
	}

	public void beforeGetByBarCodeEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeGetByBarCodeEvent");
	}

	public void beforeGetByIDEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeGetByIDEvent");
	}

	public void beforeGetFieldEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeGetFieldEvent");
	}

	public void beforeSetFieldEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeSetFieldEvent");
	}

	public void beforeSupercedeEvent(EventObject e)
			throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeSupercedeEvent");
	}

	public void beforeTransitionEvent(EventObject e)
			throws RecordManagerException {

		logger.debug("entered");
		HashMap map = (HashMap)e.getSource();
		Long filePlanComponentID = (Long) map.get(ExtensionParamKeys.FILE_PLAN_COMPONENT_ID);
		Long phaseID = (Long) map.get(ExtensionParamKeys.PHASE_ID);
		logger.debug("phase id = " + phaseID);
		if(phaseID != DispositionTypes.ACCESSION && phaseID != DispositionTypes.EXPORT) return;
		StateMachine stateMachine = (StateMachine)map.get(ExtensionParamKeys.STATE_MACHINE);
		//User user = (User)stateMachine.getAttribute(StateMachineKeys.USER);
	   	//DBConfig dbConfig = (DBConfig)stateMachine.getAttribute(StateMachineKeys.DATASOURCE);
		
	   	logger.info("Getting file plan component controller...");
		//Using the stateMachine to obtain the local stateful session bean FilePlanComponentControllerEJBLocal
		try{	
			ServiceLocator locator = ServiceLocator.getInstance();
			Object obj = locator.lookup("local:ejb/" + BusinessComponentsJNDINames.FILE_PLAN_COMPONENT_CONTROLLER_JNDI);
	
			FilePlanComponentControllerEJBLocalHome uch = (FilePlanComponentControllerEJBLocalHome) PortableRemoteObject.narrow(obj, FilePlanComponentControllerEJBLocalHome.class);
			FilePlanComponentControllerEJBLocal ucl = null;
			ucl = uch.create(stateMachine);			
			logger.debug("file plan component controller has been created");
			
			long viewId = ucl.getFilePlanComponentPrimaryViewId(filePlanComponentID);
			
			obj = locator.lookup("local:ejb/" + BusinessComponentsJNDINames.NAVIGATION_CONTROLLER_JNDI);
			NavigationControllerEJBLocalHome nch = (NavigationControllerEJBLocalHome) PortableRemoteObject.narrow(obj, NavigationControllerEJBLocalHome.class);
			NavigationControllerEJBLocal ncl = null;
			ncl = nch.create(stateMachine);
			
			logger.debug("Navigation controller has been created");
			
			String parentStr = ncl.getSourceList(viewId, filePlanComponentID, 0, 1);
			logger.debug("Parent xml = " + parentStr);
			Document document = XMLUtil.getDocument(parentStr);
			Node node = XMLUtil.getNodeByXPath(document, "/List/Item");
			long parentId = XMLUtil.getLongValueFromXMLAttribute(node, "FlPlnCmpntID");
			
			parentStr = ncl.getSourceList(viewId, parentId, 0, 1);
			logger.debug("Parent xml2 = " + parentStr);
			document = XMLUtil.getDocument(parentStr);
			node = XMLUtil.getNodeByXPath(document, "/List/Item");
			parentId = XMLUtil.getLongValueFromXMLAttribute(node, "FlPlnCmpntID");
			String flag = ucl.getFilePlanComponentField(parentId, "TS_TransferToNara");
			logger.info("check transfer to nara flag = " + flag);
			if(!flag.equals("1")) return;
			obj = locator.lookup("local:ejb/" + BusinessComponentsJNDINames.FILE_PLAN_CONTENT_CONTROLLER_JNDI);
			FilePlanComponentContentControllerEJBLocalHome ucch = (FilePlanComponentContentControllerEJBLocalHome) PortableRemoteObject.narrow(obj, FilePlanComponentContentControllerEJBLocalHome.class);
			FilePlanComponentContentControllerEJBLocal uccl = null;
			uccl = ucch.create(stateMachine);
			logger.debug("file plan component content controller has been created");
			
			String contentXml = uccl.getContentList(filePlanComponentID);
			logger.debug("Content xml = " + contentXml);
			Document doc = XMLUtil.getDocument(contentXml);
			NodeList nl = XMLUtil.getNodeList(doc, "Item");
			for(int i = 0 ; i < nl.getLength() ; ++ i){
				String attr = nl.item(i).getAttributes().getNamedItem("ContentName").getNodeValue();
				logger.debug("Node value = " + attr);
				if(attr.substring(attr.lastIndexOf('.') + 1).equalsIgnoreCase("pdf")){
					map.put(ExtensionParamKeys.LOG, "Important: To transfer or accession your records to NARA, you must include embedded fonts with your PDF files.");
					break;
				}
			}
			//map.put(ExtensionParamKeys.LOG, "Important: To transfer or accession your records to NARA, you must include embedded fonts with your PDF files.");
		}
		catch(RecordManagerException ex){
			if(ex.getErrorKey() != BusinessLayerError.FILE_PLAN_COMPONENT_INVALID_EXTERNAL_RECORD){
				throw ex;
			}
		}
		catch(NamingException ex){
			RecordManagerException rme = new RecordManagerException(BusinessLayerError.JNDI_LOOKUP_FAILED, ex.getMessage(), getClass().getName(), RecordManagerExceptionTypes.BUSINESS_LOGIC, ex);
			rme.addMessageParameter(ex.getMessage());
			throw rme;
		}
		catch(CreateException ce){
			logger.debug("Extension exception:", ce);			
			throw new RecordManagerException(BusinessLayerError.UNKNOWN, ce.getMessage(), getClass().getName(), RecordManagerExceptionTypes.SYSTEM, ce);
		}
		catch(Exception ex){
			logger.debug("Extension exception:", ex);			
			throw new RecordManagerException(BusinessLayerError.UNKNOWN, ex.getMessage(), getClass().getName(), RecordManagerExceptionTypes.SYSTEM, ex);
		}
		logger.info("The end of afterTransitionEvent Listener...");
	}

	public void beforeUpdateEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("beforeUpdateEvent");
	}

	public void afterTransitionExportToSpecificSchemaEvent(EventObject e) throws RecordManagerException {
		// TODO Auto-generated method stub
		logger.debug("afterTransitionExportToSpecificSchema");
	}
	
}
